## ignition-physics4 4.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1 FATAL_ERROR)

#============================================================================
# Initialize the project
#============================================================================
project(ignition-physics4 VERSION 4.1.0)

#============================================================================
# Find ignition-cmake
#============================================================================
find_package(ignition-cmake2 2.1.0 REQUIRED)

#============================================================================
# Configure the project
#============================================================================
ign_configure_project()


#============================================================================
# Set project-specific options
#============================================================================

option(ENABLE_PROFILER "Enable Ignition Profiler" FALSE)

if(ENABLE_PROFILER)
  add_definitions("-DIGN_PROFILER_ENABLE=1")
else()
  add_definitions("-DIGN_PROFILER_ENABLE=0")
endif()

#============================================================================
# Search for project-specific dependencies
#============================================================================
message(STATUS "\n\n-- ====== Finding Dependencies ======")

#--------------------------------------
# Find ignition-common
ign_find_package(ignition-common4
  COMPONENTS graphics profiler
  REQUIRED_BY mesh dartsim tpe tpelib)
set(IGN_COMMON_VER ${ignition-common4_VERSION_MAJOR})

#--------------------------------------
# Find ignition-math
ign_find_package(ignition-math6 REQUIRED COMPONENTS eigen3)
set(IGN_MATH_VER ${ignition-math6_VERSION_MAJOR})

#--------------------------------------
# Find ignition-plugin
ign_find_package(ignition-plugin1 REQUIRED COMPONENTS all VERSION 1.1)
set(IGN_PLUGIN_VER ${ignition-plugin1_VERSION_MAJOR})

#--------------------------------------
# Find ignition-utils
ign_find_package(ignition-utils1 REQUIRED COMPONENTS cli)
set(IGN_UTILS_VER ${ignition-utils1_VERSION_MAJOR})

#--------------------------------------
# Find Eigen
ign_find_package(EIGEN3 REQUIRED)

#--------------------------------------
# Find SDFormat for the SDF features
ign_find_package(sdformat11
  REQUIRED_BY sdf dartsim tpe)

#--------------------------------------
# Find dartsim for the dartsim plugin wrapper
ign_find_package(DART
  COMPONENTS
    collision-bullet
    collision-ode
    utils
    utils-urdf
  EXTRA_ARGS CONFIG
  VERSION 6.9
  REQUIRED_BY dartsim
  PKGCONFIG dart
  PKGCONFIG_VER_COMPARISON >=)


message(STATUS "-------------------------------------------\n")

set(IGNITION_PHYSICS_RESOURCE_DIR "${CMAKE_SOURCE_DIR}/resources")

# Plugin install dirs
set(IGNITION_PHYSICS_ENGINE_INSTALL_DIR
  ${CMAKE_INSTALL_PREFIX}/${IGN_LIB_INSTALL_DIR}/ign-${IGN_DESIGNATION}-${PROJECT_VERSION_MAJOR}/engine-plugins
)

#============================================================================
# Configure the build
#============================================================================
ign_configure_build(QUIT_IF_BUILD_ERRORS
  COMPONENTS sdf mesh dartsim tpe)


#============================================================================
# Create package information
#============================================================================
ign_create_packages()


#============================================================================
# Create documentation
#============================================================================
configure_file(${CMAKE_SOURCE_DIR}/api.md.in ${CMAKE_BINARY_DIR}/api.md)
configure_file(${CMAKE_SOURCE_DIR}/tutorials.md.in ${CMAKE_BINARY_DIR}/tutorials.md)

ign_create_docs(
  API_MAINPAGE_MD "${CMAKE_BINARY_DIR}/api.md"
  TUTORIALS_MAINPAGE_MD "${CMAKE_BINARY_DIR}/tutorials.md"
  TAGFILES
    "${IGNITION-COMMON_DOXYGEN_TAGFILE} = ${IGNITION-COMMON_API_URL}"
    "${IGNITION-PLUGIN_DOXYGEN_TAGFILE} = ${IGNITION-PLUGIN_API_URL}"
    "${IGNITION-MATH_DOXYGEN_TAGFILE} = ${IGNITION-MATH_API_URL}"
  )

=== dartsim/CMakeLists.txt ===

# This component expresses custom features of the dartsim plugin, which can
# expose native dartsim data types.
ign_add_component(dartsim INTERFACE
  DEPENDS_ON_COMPONENTS sdf mesh
  GET_TARGET_NAME features)

target_link_libraries(${features} INTERFACE ${DART_LIBRARIES})
target_include_directories(${features} SYSTEM INTERFACE ${DART_INCLUDE_DIRS})
if (MSVC)
  # needed by DART, see https://github.com/dartsim/dart/issues/753
  target_compile_options(${features} INTERFACE "/permissive-")
endif()

install(
  DIRECTORY include/
  DESTINATION "${IGN_INCLUDE_INSTALL_DIR_FULL}")

ign_get_libsources_and_unittests(sources test_sources)

# TODO(MXG): Think about an ign_add_plugin(~) macro for ign-cmake
set(engine_name dartsim-plugin)
ign_add_component(${engine_name}
  SOURCES ${sources}
  DEPENDS_ON_COMPONENTS dartsim
  GET_TARGET_NAME dartsim_plugin)

target_link_libraries(${dartsim_plugin}
  PUBLIC
    ${features}
    ${PROJECT_LIBRARY_TARGET_NAME}-sdf
    ${PROJECT_LIBRARY_TARGET_NAME}-mesh
    ignition-common${IGN_COMMON_VER}::ignition-common${IGN_COMMON_VER}
    ignition-math${IGN_MATH_VER}::eigen3
  PRIVATE
    # We need to link this, even when the profiler isn't used to get headers.
    ignition-common${IGN_COMMON_VER}::profiler
)

# Note that plugins are currently being installed in 2 places: /lib and the engine-plugins dir
install(TARGETS ${dartsim_plugin} DESTINATION ${IGNITION_PHYSICS_ENGINE_INSTALL_DIR})

# The library created by `ign_add_component` includes the ign-physics version
# (i.e. libignition-physics1-name-plugin.so), but for portability,
# we also install an unversioned symlink into the same versioned folder.
set(versioned ${CMAKE_SHARED_LIBRARY_PREFIX}${dartsim_plugin}${CMAKE_SHARED_LIBRARY_SUFFIX})
set(unversioned ${CMAKE_SHARED_LIBRARY_PREFIX}${PROJECT_NAME_NO_VERSION_LOWER}-${engine_name}${CMAKE_SHARED_LIBRARY_SUFFIX})
if (WIN32)
  # disable MSVC inherit via dominance warning
  target_compile_options(${dartsim_plugin} PUBLIC "/wd4250")
  INSTALL(CODE "EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E copy
      ${IGNITION_PHYSICS_ENGINE_INSTALL_DIR}\/${versioned}
      ${IGNITION_PHYSICS_ENGINE_INSTALL_DIR}\/${unversioned})")
else()
  EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E create_symlink ${versioned} ${unversioned})
  INSTALL(FILES ${PROJECT_BINARY_DIR}/${unversioned} DESTINATION ${IGNITION_PHYSICS_ENGINE_INSTALL_DIR})
endif()

# Testing
ign_build_tests(
  TYPE UNIT
  SOURCES ${test_sources}
  LIB_DEPS
    ${features}
    ignition-plugin${IGN_PLUGIN_VER}::loader
    ignition-common${IGN_COMMON_VER}::ignition-common${IGN_COMMON_VER}
    ${PROJECT_LIBRARY_TARGET_NAME}-sdf
    ${PROJECT_LIBRARY_TARGET_NAME}-mesh
  TEST_LIST tests)

foreach(test ${tests})

  target_compile_definitions(${test} PRIVATE
    "dartsim_plugin_LIB=\"$<TARGET_FILE:${dartsim_plugin}>\""
    "TEST_WORLD_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}/worlds/\""
    "IGNITION_PHYSICS_RESOURCE_DIR=\"${IGNITION_PHYSICS_RESOURCE_DIR}\"")

  # Helps when we want to build a single test after making changes to dartsim_plugin
  add_dependencies(${test} ${dartsim_plugin})
endforeach()

foreach(test UNIT_FindFeatures_TEST UNIT_RequestFeatures_TEST)
  if(TARGET ${test})
    target_compile_definitions(${test} PRIVATE
      "dartsim_plugin_LIB=\"$<TARGET_FILE:${dartsim_plugin}>\"")
  endif()
endforeach()

=== src/CMakeLists.txt ===
ign_get_libsources_and_unittests(sources gtest_sources)

ign_create_core_library(SOURCES ${sources} CXX_STANDARD 17)

target_link_libraries(${PROJECT_LIBRARY_TARGET_NAME}
  PUBLIC
    ${ignition-math${IGN_MATH_VER}_LIBRARIES}
    ignition-utils${IGN_UTILS_VER}::ignition-utils${IGN_UTILS_VER}
    ignition-plugin${IGN_PLUGIN_VER}::register)

target_include_directories(${PROJECT_LIBRARY_TARGET_NAME}
  SYSTEM PUBLIC
    ${EIGEN3_INCLUDE_DIRS})

ign_build_tests(
  TYPE UNIT
  SOURCES ${gtest_sources})

if(TARGET UNIT_FindFeatures_TEST)
  target_link_libraries(UNIT_FindFeatures_TEST
    ignition-plugin${IGN_PLUGIN_VER}::loader)
endif()

=== debian/changelog ===
ignition-physics4 (4.1.0-1~buster) buster; urgency=medium

  * ignition-physics4 4.1.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Mon, 03 May 2021 09:08:56 -0700

ignition-physics4 (4.0.0-1~buster) buster; urgency=medium

  * ignition-physics4 4.0.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Wed, 31 Mar 2021 14:24:42 -0700

ignition-physics4 (4.0.0~pre1-1~buster) buster; urgency=medium

  * ignition-physics4 4.0.0~pre1-1 release

 -- Louise Poubel <louise@openrobotics.org>  Thu, 25 Mar 2021 14:59:36 -0700

ignition-physics4 (3.999.999-1~buster) buster; urgency=medium

  * Stub to be removed after first entry

 -- Louise Poubel <louise@openrobotics.org>  Wed, 07 Oct 2020 17:35:46 -0700

=== debian/control ===
Source: ignition-physics4
Standards-Version: 3.9.8
Maintainer: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Priority: optional
Build-Depends: cmake,
               pkg-config,
               debhelper (>= 9),
               libignition-cmake2-dev (>= 2.1.0),
               libignition-common4-graphics-dev,
               libignition-common4-profiler-dev,
               libignition-math6-dev,
               libignition-math6-eigen3-dev,
               libignition-plugin-dev (>= 1.1.0),
               libignition-utils1-dev,
               libignition-utils1-cli-dev,
# dart without major version number to get versions coming from Debian
               libdart6-dev (<< 6.10.0) | libdart-dev (<< 6.10.0),
               libdart6-collision-bullet-dev (<< 6.10.0) | libdart-collision-bullet-dev (<< 6.10.0),
               libdart6-collision-ode-dev (<< 6.10.0) | libdart-collision-ode-dev (<< 6.10.0),
               libdart6-external-ikfast-dev (<< 6.10.0) | libdart-external-ikfast-dev (<< 6.10.0),
               libdart6-external-odelcpsolver-dev (<< 6.10.0) | libdart-external-odelcpsolver-dev (<< 6.10.0),
               libdart6-utils-dev (<< 6.10.0) | libdart-utils-dev (<< 6.10.0),
               libdart6-utils-urdf-dev (<< 6.10.0) | libdart-utils-urdf-dev (<< 6.10.0),
               libsdformat11-dev
Vcs-Browser: https://github.com/ignition-release/ign-physics4-release
Vcs-Git: https://github.com/ignition-release/ign-physics4-release
Homepage: http://ignitionrobotics.org/

Package: libignition-physics4-core-dev
Architecture: any
Section: libdevel
Depends: libignition-cmake2-dev (>= 2.1.0),
         libignition-math6-dev,
         libignition-plugin-dev (>= 1.1.0),
         libignition-physics4 (= ${binary:Version}),
         libignition-utils1-dev,
         ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - Development files
  Ignition Physics is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Core component, development files

Package: libignition-physics4-sdf-dev
Architecture: any
Section: libdevel
Depends: libignition-physics4-core-dev,
         libignition-cmake2-dev (>= 2.1.0),
         libsdformat11-dev,
         libignition-physics4 (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - SDF Dev files
  Ignition Physics is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  SDF component, development files

Package: libignition-physics4-mesh-dev
Architecture: any
Section: libdevel
Depends: libignition-physics4-core-dev,
         libignition-cmake2-dev (>= 2.1.0),
         libignition-common4-graphics-dev,
         libignition-physics4 (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - Mesh Dev files
  Ignition Physics is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Mesh component, development files

Package: libignition-physics4
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - Shared library
  Ignition Physics is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Main shared library

Package: libignition-physics4-dartsim-dev
Architecture: any
Section: libdevel
Depends: libignition-physics4-core-dev,
         libignition-physics4-sdf-dev,
         libignition-physics4-mesh-dev,
         libignition-cmake2-dev (>= 2.1.0),
         libignition-common4-graphics-dev,
         libignition-math6-dev,
         libignition-math6-eigen3-dev,
         libignition-plugin-dev (>= 1.1.0),
         libdart6-dev (<< 6.10.0) | libdart-dev (<< 6.10.0),
         libdart6-collision-ode-dev (<< 6.10.0) | libdart-collision-ode-dev (<< 6.10.0),
         libdart6-utils-dev (<< 6.10.0) | libdart-utils-dev (<< 6.10.0),
         libdart6-utils-urdf-dev (<< 6.10.0) | libdart-utils-urdf-dev (<< 6.10.0),
         libdart6-external-odelcpsolver-dev (<< 6.10.0) | libdart-external-odelcpsolver-dev (<< 6.10.0),
         libdart6-external-ikfast-dev (<< 6.10.0) | libdart-external-ikfast-dev (<< 6.10.0),
         libdart6-collision-bullet-dev (<< 6.10.0) | libdart-collision-bullet-dev (<< 6.10.0),
         libsdformat11-dev,
         libignition-physics4-dartsim (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - Development files
  Ignition Physics is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Dartsim component, development files

Package: libignition-physics4-dartsim
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - Dartsim library
  Ignition Physics is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  DARTSim component shared library

Package: libignition-physics4-tpe-dev
Architecture: any
Section: libdevel
Depends: libignition-physics4-core-dev,
         libignition-physics4-sdf-dev,
         libignition-physics4-mesh-dev,
         libignition-cmake2-dev (>= 2.1.0),
         libignition-math6-dev,
         libignition-math6-eigen3-dev,
         libignition-plugin-dev (>= 1.1.0),
         libsdformat11-dev,
         libignition-physics4-tpe (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - Development files
  Ignition Physics is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  TPE plugin component, development files

Package: libignition-physics4-tpe
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - TPE library
  Ignition Physics is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  TPE plugin component shared library

Package: libignition-physics4-tpelib-dev
Architecture: any
Section: libdevel
Depends: libignition-cmake2-dev (>= 2.1.0),
         libignition-math6-dev,
         libignition-math6-eigen3-dev,
         libignition-plugin-dev (>= 1.1.0),
         libignition-physics4-tpelib (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - Development files
  Ignition Physics is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  TPE library component, development files

Package: libignition-physics4-tpelib
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - TPE library
  Ignition Physics is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  TPE library component shared library

Package: libignition-physics4-dev
Architecture: any
Section: libdevel
Depends: libignition-physics4-core-dev,
         libignition-physics4-dartsim-dev,
         libignition-physics4-mesh-dev,
         libignition-physics4-sdf-dev,
         libignition-physics4-tpe-dev,
         libignition-physics4-tpelib-dev,
         ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - Metapackage
  Ignition Physics is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Metapackage, all development files

=== debian/rules ===
#!/usr/bin/make -f

.PHONY: override_dh_auto_configure \
        override_dh_install \
        override_dh_auto_test

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DCMAKE_BUILD_TYPE=RelWithDebInfo

override_dh_install:
	dh_install --
	dh_missing --list-missing

# test cannot run in parallel
# arm64 problems https://github.com/ignitionrobotics/ign-physics/issues/70
override_dh_auto_test:
ifeq ($(DEB_HOST_ARCH),arm64)
	true
else
	dh_auto_test --max-parallel=1
endif

## ignition-physics4 4.3.0-1~focal

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,18 +3,17 @@
 #============================================================================
 # Initialize the project
 #============================================================================
-project(ignition-physics4 VERSION 4.1.0)
+project(ignition-physics4 VERSION 4.3.0)
 
 #============================================================================
 # Find ignition-cmake
 #============================================================================
-find_package(ignition-cmake2 2.1.0 REQUIRED)
+find_package(ignition-cmake2 2.8.0 REQUIRED)
 
 #============================================================================
 # Configure the project
 #============================================================================
-ign_configure_project()
-
+ign_configure_project(VERSION_SUFFIX)
 
 #============================================================================
 # Set project-specific options
@@ -37,7 +36,7 @@
 # Find ignition-common
 ign_find_package(ignition-common4
   COMPONENTS graphics profiler
-  REQUIRED_BY mesh dartsim tpe tpelib)
+  REQUIRED_BY heightmap mesh dartsim tpe tpelib bullet)
 set(IGN_COMMON_VER ${ignition-common4_VERSION_MAJOR})
 
 #--------------------------------------
@@ -61,8 +60,8 @@
 
 #--------------------------------------
 # Find SDFormat for the SDF features
-ign_find_package(sdformat11
-  REQUIRED_BY sdf dartsim tpe)
+ign_find_package(sdformat11 VERSION 11.2.2
+  REQUIRED_BY sdf dartsim tpe bullet)
 
 #--------------------------------------
 # Find dartsim for the dartsim plugin wrapper
@@ -78,6 +77,13 @@
   PKGCONFIG dart
   PKGCONFIG_VER_COMPARISON >=)
 
+#--------------------------------------
+# Find bullet for the bullet plugin wrapper
+ign_find_package(IgnBullet
+  VERSION 2.87
+  REQUIRED_BY bullet
+  PKGCONFIG bullet
+  PKGCONFIG_VER_COMPARISON >=)
 
 message(STATUS "-------------------------------------------\n")
 
@@ -92,7 +98,7 @@
 # Configure the build
 #============================================================================
 ign_configure_build(QUIT_IF_BUILD_ERRORS
-  COMPONENTS sdf mesh dartsim tpe)
+  COMPONENTS sdf heightmap mesh dartsim tpe bullet)
 
 
 #============================================================================
@@ -115,3 +121,5 @@
     "${IGNITION-PLUGIN_DOXYGEN_TAGFILE} = ${IGNITION-PLUGIN_API_URL}"
     "${IGNITION-MATH_DOXYGEN_TAGFILE} = ${IGNITION-MATH_API_URL}"
   )
+
+file(COPY ${CMAKE_SOURCE_DIR}/tutorials/img/ DESTINATION ${CMAKE_BINARY_DIR}/doxygen/html/img/)

=== bullet/CMakeLists.txt ===
# This component expresses custom features of the bullet plugin, which can
# expose native bullet data types.
ign_add_component(bullet INTERFACE
  DEPENDS_ON_COMPONENTS sdf mesh
  GET_TARGET_NAME features)

link_directories(${BULLET_LIBRARY_DIRS})
target_link_libraries(${features} INTERFACE IgnBullet::IgnBullet)

ign_get_libsources_and_unittests(sources test_sources)

# TODO(MXG): Think about an ign_add_plugin(~) macro for ign-cmake
set(engine_name bullet-plugin)
ign_add_component(${engine_name}
  SOURCES ${sources}
  DEPENDS_ON_COMPONENTS bullet
  GET_TARGET_NAME bullet_plugin)

target_link_libraries(${bullet_plugin}
  PUBLIC
    ${features}
    ${PROJECT_LIBRARY_TARGET_NAME}-sdf
    ${PROJECT_LIBRARY_TARGET_NAME}-mesh
    ignition-common${IGN_COMMON_VER}::ignition-common${IGN_COMMON_VER}
    ignition-math${IGN_MATH_VER}::eigen3)

# Note that plugins are currently being installed in 2 places: /lib and the engine-plugins dir
install(TARGETS ${bullet_plugin} DESTINATION ${IGNITION_PHYSICS_ENGINE_INSTALL_DIR})

# The library created by `ign_add_component` includes the ign-physics version
# (i.e. libignition-physics1-name-plugin.so), but for portability,
# we also install an unversioned symlink into the same versioned folder.
set(versioned ${CMAKE_SHARED_LIBRARY_PREFIX}${bullet_plugin}${CMAKE_SHARED_LIBRARY_SUFFIX})
set(unversioned ${CMAKE_SHARED_LIBRARY_PREFIX}${PROJECT_NAME_NO_VERSION_LOWER}-${engine_name}${CMAKE_SHARED_LIBRARY_SUFFIX})
if (WIN32)
  # disable MSVC inherit via dominance warning
  target_compile_options(${dartsim_plugin} PUBLIC "/wd4250")
  INSTALL(CODE "EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E copy
      ${IGNITION_PHYSICS_ENGINE_INSTALL_DIR}\/${versioned}
      ${IGNITION_PHYSICS_ENGINE_INSTALL_DIR}\/${unversioned})")
else()
  EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E create_symlink ${versioned} ${unversioned})
  INSTALL(FILES ${PROJECT_BINARY_DIR}/${unversioned} DESTINATION ${IGNITION_PHYSICS_ENGINE_INSTALL_DIR})
endif()
EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E create_symlink ${versioned} ${unversioned})
INSTALL(FILES ${PROJECT_BINARY_DIR}/${unversioned} DESTINATION ${IGNITION_PHYSICS_ENGINE_INSTALL_DIR})

# Testing
ign_build_tests(
  TYPE UNIT_bullet
  SOURCES ${test_sources}
  LIB_DEPS
    ${features}
    ignition-plugin${IGN_PLUGIN_VER}::loader
    ignition-common${IGN_COMMON_VER}::ignition-common${IGN_COMMON_VER}
    ${PROJECT_LIBRARY_TARGET_NAME}-sdf
    ${PROJECT_LIBRARY_TARGET_NAME}-mesh
  TEST_LIST tests)

foreach(test ${tests})

  target_compile_definitions(${test} PRIVATE
    "bullet_plugin_LIB=\"$<TARGET_FILE:${bullet_plugin}>\""
    "TEST_WORLD_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}/worlds/\""
    "IGNITION_PHYSICS_RESOURCE_DIR=\"${IGNITION_PHYSICS_RESOURCE_DIR}\"")

endforeach()

if(TARGET UNIT_FindFeatures_TEST)

  target_compile_definitions(UNIT_FindFeatures_TEST PRIVATE
    "bullet_plugin_LIB=\"$<TARGET_FILE:${bullet_plugin}>\"")

endif()

=== examples/hello_world_loader/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5 FATAL_ERROR)

set(IGN_PLUGIN_VER 1)
find_package(ignition-plugin${IGN_PLUGIN_VER} 1.1 REQUIRED COMPONENTS all)

set(IGN_PHYSICS_VER 4)
find_package(ignition-physics${IGN_PHYSICS_VER} REQUIRED)

add_executable(hello_world_loader hello_world_loader.cc)
target_link_libraries(hello_world_loader
  ignition-plugin${IGN_PLUGIN_VER}::loader
  ignition-physics${IGN_PHYSICS_VER}::ignition-physics${IGN_PHYSICS_VER})

=== examples/hello_world_plugin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5 FATAL_ERROR)

set(IGN_PLUGIN_VER 1)
find_package(ignition-plugin${IGN_PLUGIN_VER} 1.1 REQUIRED COMPONENTS all)

set(IGN_PHYSICS_VER 4)
find_package(ignition-physics${IGN_PHYSICS_VER} REQUIRED)

add_library(HelloWorldPlugin SHARED HelloWorldPlugin.cc)
target_link_libraries(HelloWorldPlugin
  PRIVATE
    ignition-physics${IGN_PHYSICS_VER}::ignition-physics${IGN_PHYSICS_VER})

=== examples/simple_plugin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5 FATAL_ERROR)

set(IGN_PLUGIN_VER 1)
find_package(ignition-plugin${IGN_PLUGIN_VER} 1.1 REQUIRED COMPONENTS all)

set(IGN_PHYSICS_VER 4)
find_package(ignition-physics${IGN_PHYSICS_VER} REQUIRED)

add_library(SimplePlugin SHARED plugin.cc EntityManagementFeatures.cc)
target_link_libraries(SimplePlugin
  PRIVATE
    ignition-physics${IGN_PHYSICS_VER}::ignition-physics${IGN_PHYSICS_VER})

add_executable(PluginTest EntityManagementFeatures_TEST.cc)
target_link_libraries(PluginTest
  ignition-plugin${IGN_PLUGIN_VER}::loader
  ignition-physics${IGN_PHYSICS_VER}::ignition-physics${IGN_PHYSICS_VER})

target_compile_definitions(PluginTest PRIVATE
  "simple_plugin_LIB=\"$<TARGET_FILE:SimplePlugin>\"")

=== debian/changelog ===
ignition-physics4 (4.3.0-1~focal) focal; urgency=medium

  * ignition-physics4 4.3.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Thu, 11 Nov 2021 10:18:02 -0800

ignition-physics4 (4.2.0-1~focal) focal; urgency=medium

  * ignition-physics4 4.2.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Fri, 16 Jul 2021 14:44:47 -0700

ignition-physics4 (4.2.0~pre1-1~focal) focal; urgency=medium

  * ignition-physics4 4.2.0~pre1-1 release

 -- Steve Peters <scpeters@openrobotics.org>  Thu, 15 Jul 2021 15:05:37 -0700

ignition-physics4 (4.1.0-1~focal) focal; urgency=medium

  * ignition-physics4 4.1.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Mon, 03 May 2021 09:08:56 -0700

ignition-physics4 (4.0.0-1~focal) focal; urgency=medium

  * ignition-physics4 4.0.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Wed, 31 Mar 2021 14:24:42 -0700

ignition-physics4 (4.0.0~pre1-1~focal) focal; urgency=medium

  * ignition-physics4 4.0.0~pre1-1 release

 -- Louise Poubel <louise@openrobotics.org>  Thu, 25 Mar 2021 14:59:36 -0700

ignition-physics4 (3.999.999-1~focal) focal; urgency=medium

  * Stub to be removed after first entry

 -- Louise Poubel <louise@openrobotics.org>  Wed, 07 Oct 2020 17:35:46 -0700

=== debian/control ===
Source: ignition-physics4
Standards-Version: 3.9.8
Maintainer: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Priority: optional
Build-Depends: cmake,
               pkg-config,
               debhelper (>= 9),
               libbullet-dev,
               libignition-cmake2-dev (>= 2.1.0),
               libignition-common4-graphics-dev,
               libignition-common4-profiler-dev,
               libignition-math6-dev,
               libignition-math6-eigen3-dev,
               libignition-plugin-dev (>= 1.1.0),
               libignition-utils1-dev,
               libignition-utils1-cli-dev,
               libdart6-dev (<< 6.10.0) | libdart-dev (>> 6.9.0),
               libdart6-collision-bullet-dev (<< 6.10.0) | libdart-collision-bullet-dev (>> 6.9.0),
               libdart6-collision-ode-dev (<< 6.10.0) | libdart-collision-ode-dev (>> 6.9.0),
               libdart6-external-ikfast-dev (<< 6.10.0) | libdart-external-ikfast-dev (>> 6.9.0),
               libdart6-external-odelcpsolver-dev (<< 6.10.0) | libdart-external-odelcpsolver-dev (>> 6.9.0),
               libdart6-utils-dev (<< 6.10.0) | libdart-utils-dev (>> 6.9.0),
               libdart6-utils-urdf-dev (<< 6.10.0) | libdart-utils-urdf-dev (>> 6.9.0),
               libsdformat11-dev (>= 11.2.2)
Vcs-Browser: https://github.com/ignition-release/ign-physics4-release
Vcs-Git: https://github.com/ignition-release/ign-physics4-release
Homepage: http://ignitionrobotics.org/

Package: libignition-physics4-core-dev
Architecture: any
Section: libdevel
Depends: libignition-cmake2-dev (>= 2.1.0),
         libignition-math6-dev,
         libignition-plugin-dev,
         libignition-physics4 (= ${binary:Version}),
         libignition-utils1-dev,
         ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - Development files
  Ignition Physics is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Core component, development files

Package: libignition-physics4-sdf-dev
Architecture: any
Section: libdevel
Depends: libignition-physics4-core-dev (= ${binary:Version}),
         libignition-cmake2-dev (>= 2.1.0),
         libsdformat11-dev (>= 11.2.2),
         libignition-physics4 (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - SDF Dev files
  Ignition Physics is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  SDF component, development files

Package: libignition-physics4-mesh-dev
Architecture: any
Section: libdevel
Depends: libignition-physics4-core-dev (= ${binary:Version}),
         libignition-cmake2-dev (>= 2.1.0),
         libignition-common4-graphics-dev,
         libignition-physics4 (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - Mesh Dev files
  Ignition Physics is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Mesh component, development files

Package: libignition-physics4-heightmap-dev
Architecture: any
Section: libdevel
Depends: libignition-physics4-core-dev (= ${binary:Version}),
         libignition-cmake2-dev (>= 2.1.0),
         libignition-common4-graphics-dev,
         libignition-physics4 (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - Heightmap Dev files
  Ignition Physics is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Heightmap component, development files

Package: libignition-physics4
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - Shared library
  Ignition Physics is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Main shared library

Package: libignition-physics4-dartsim-dev
Architecture: any
Section: libdevel
Depends: libignition-physics4-core-dev (= ${binary:Version}),
         libignition-physics4-sdf-dev (= ${binary:Version}),
         libignition-physics4-mesh-dev (= ${binary:Version}),
         libignition-physics4-heightmap-dev (= ${binary:Version}),
         libignition-cmake2-dev (>= 2.1.0),
         libignition-common4-graphics-dev,
         libignition-math6-dev,
         libignition-math6-eigen3-dev,
         libignition-plugin-dev,
         libdart6-dev (>> 6.9.0) | libdart-dev (>> 6.9.0),
         libdart6-collision-ode-dev (<< 6.10.0) | libdart-collision-ode-dev (>> 6.9.0),
         libdart6-utils-urdf-dev (<< 6.10.0) | libdart-utils-urdf-dev (>> 6.9.0),
# following dart dependencies are not direct dependencies
# added here to force upgrade from 6.7.2
         libdart6-utils-dev (<< 6.10.0) | libdart-utils-dev (>> 6.9.0),
         libdart6-external-odelcpsolver-dev (<< 6.10.0) | libdart-external-odelcpsolver-dev (>> 6.9.0),
         libdart6-external-ikfast-dev (<< 6.10.0) | libdart-external-ikfast-dev (>> 6.9.0),
         libdart6-collision-bullet-dev (<< 6.10.0) | libdart-collision-bullet-dev (>> 6.9.0),
         libsdformat11-dev (>= 11.2.2),
         libignition-physics4-dartsim (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - Development files
  Ignition Physics is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Dartsim component, development files

Package: libignition-physics4-dartsim
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - Dartsim library
  Ignition Physics is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  DARTSim component shared library

Package: libignition-physics4-tpe-dev
Architecture: any
Section: libdevel
Depends: libignition-physics4-core-dev (= ${binary:Version}),
         libignition-physics4-sdf-dev (= ${binary:Version}),
         libignition-physics4-mesh-dev (= ${binary:Version}),
         libignition-cmake2-dev (>= 2.1.0),
         libignition-math6-dev,
         libignition-math6-eigen3-dev,
         libignition-plugin-dev (>= 1.1.0),
         libsdformat11-dev (>= 11.2.2),
         libignition-physics4-tpe (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - Development files
  Ignition Physics is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  TPE plugin component, development files

Package: libignition-physics4-tpe
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - TPE library
  Ignition Physics is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  TPE plugin component shared library

Package: libignition-physics4-tpelib-dev
Architecture: any
Section: libdevel
Depends: libignition-cmake2-dev (>= 2.1.0),
         libignition-math6-dev,
         libignition-math6-eigen3-dev,
         libignition-plugin-dev (>= 1.1.0),
         libignition-physics4-tpelib (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - Development files
  Ignition Physics is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  TPE library component, development files

Package: libignition-physics4-tpelib
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - TPE library
  Ignition Physics is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  TPE library component shared library

Package: libignition-physics4-bullet-dev
Architecture: any
Section: libdevel
Depends: libignition-physics4-core-dev (= ${binary:Version}),
         libignition-physics4-sdf-dev (= ${binary:Version}),
         libignition-physics4-mesh-dev (= ${binary:Version}),
         libignition-cmake2-dev (>= 2.1.0),
         libignition-common4-graphics-dev,
         libignition-math6-dev,
         libignition-math6-eigen3-dev,
         libignition-plugin-dev,
         libbullet-dev,
         libsdformat11-dev (>= 11.2.2),
         libignition-physics4-bullet (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - Development files
  Ignition Physics is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Bullet component, development files

Package: libignition-physics4-bullet
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - Bullet engine
  Ignition Physics is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Bullet component shared library

Package: libignition-physics4-dev
Architecture: any
Section: libdevel
Depends: libignition-physics4-core-dev (= ${binary:Version}),
         libignition-physics4-dartsim-dev (= ${binary:Version}),
         libignition-physics4-heightmap-dev (= ${binary:Version}),
         libignition-physics4-mesh-dev (= ${binary:Version}),
         libignition-physics4-sdf-dev (= ${binary:Version}),
         libignition-physics4-tpe-dev (= ${binary:Version}),
         libignition-physics4-tpelib-dev (= ${binary:Version}),
         ${misc:Depends}
# Bullet not added on purpose to avoid adding a new dependency to a stable release
Multi-Arch: same
Description: Ignition Physics classes and functions for robot apps - Metapackage
  Ignition Physics is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Metapackage, all development files
